/****************************************************************************/
/* Copyright(C)2006 Tony Bayart                                             */
/* http://www.developpez.net/forums/member.php?u=59049                      */
/* http://shenron.free.fr                                                   */
/*                                                                          */
/* This program is free software; you can redistribute it and/or modify it  */
/* under the terms of the GNU General Public License as published by the    */
/* Free Software Foundation; either version 2 of the License, or            */
/* (at your option) any later version.                                      */
/*                                                                          */
/* This program is distributed in the hope that it will be useful,          */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     */
/* See the GNU General Public License for more details.                     */
/*                                                                          */
/* You should have received a copy of the GNU General Public License along  */
/* with this program; if not, write to the Free Software Foundation, Inc.,  */
/* 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.            */
/****************************************************************************/


#include "DataBase.hpp"
#include <iostream>


CDataBase::CDataBase()
{
    // on simule la connection a une base de donnees
    std::cout << "Connection a la base de donnees" << std::endl;

    // ajoutons quelques utilisateurs
    m_mapUsers["Alpha"] = "Ahpla";
    m_mapUsers["Beta"] = "Ateb";
    m_mapUsers["Gamma"] = "Ammag";
}


CDataBase::~CDataBase()
{
    // on simule la deconnection a la base de donnees
    std::cout << "Deconnection de la base de donnees" << std::endl;
}


CDataBase::EResult CDataBase::ConnectUser(const std::string& sUsername, const std::string& sPassword) const
{
    std::cout << "User \"" << sUsername << "\" Pass \"" << sPassword << "\" : ";

    // recherche de l'utilisateur
    CDataBaseUsersMapIter itMap = m_mapUsers.find(sUsername);

	// si l'utilisateur est trouve
    if(m_mapUsers.end() != itMap)
    {
        // on verifie le mot de passe
        if(sPassword == itMap->second)
            return eSuccess;

        // mot de passe invalide
        return eInvalidPassword;
    }

    // l'utilisateur n'a pas ete trouve
    return eInvalidUser;
}
