/****************************************************************************/
/* Copyright(C)2006 Tony Bayart                                             */
/* http://www.developpez.net/forums/member.php?u=59049                      */
/* http://shenron.free.fr                                                   */
/*                                                                          */
/* This program is free software; you can redistribute it and/or modify it  */
/* under the terms of the GNU General Public License as published by the    */
/* Free Software Foundation; either version 2 of the License, or            */
/* (at your option) any later version.                                      */
/*                                                                          */
/* This program is distributed in the hope that it will be useful,          */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of           */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     */
/* See the GNU General Public License for more details.                     */
/*                                                                          */
/* You should have received a copy of the GNU General Public License along  */
/* with this program; if not, write to the Free Software Foundation, Inc.,  */
/* 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.            */
/****************************************************************************/


#ifndef DATABASE_CLASS_HEADER
#define DATABASE_CLASS_HEADER


#include <string>
#include <map>


typedef std::map<std::string,std::string>        CDataBaseUsersMap;
typedef CDataBaseUsersMap::const_iterator        CDataBaseUsersMapIter;


class CDataBase
{
public:
    enum EResult
    {
        eSuccess,
        eInvalidUser,
        eInvalidPassword,
    };


protected: // methodes protegees
    CDataBase(void);
    ~CDataBase();
    CDataBase(const CDataBase& copy);
    const CDataBase& operator=(const CDataBase& copy);


public: // methodes publiques
    static CDataBase& Instance(void)
    {
        static CDataBase instance;
        return instance;
    }

    // teste de connection d'un utilisateur
    EResult ConnectUser(const std::string& sUsername, const std::string& sPassword) const;


protected: // donnees protegees
    CDataBaseUsersMap       m_mapUsers;
};


#endif // DATABASE_CLASS_HEADER
